#!/bin/ksh

cat > $CEAACTDIR/cleanup.sh <<EOF
#!/bin/ksh
####################################################################
# Copyright:
#   Copyright (c) IBM Corp. 1998,2007. All Rights Reserved.
####################################################################
# cleanup.sh -
#  Performs cleanup task of IBM Tivoli Security Information and 
#  Event Manager Actuator for AIX, wherein any running instance(s) of 
#  TSIEM agent process(es) are terminated.
####################################################################

LOGFILE=$CEAACTDIR/cleanup.log
echo \`date\` Start of TSIEM cleanup task > \$LOGFILE
for agentPid in \`ps -e | grep "agent" | awk '{if(\$4=="agent")print \$1;}'\`
do
   if [ -n "\$agentPid" ]
   then
	tsiemAgentPid=\`ps -f -p \$agentPid | grep '../bin/agent 12.1.' | awk '{print \$2;}'\`
        tsiemAgentProcess=\`ps -f -p \$agentPid | grep '../bin/agent 12.1.' | awk '{print \$8,\$9,\$10;}'\`
        kill \$tsiemAgentPid
        if [ \$? -ne 0 ] 
        then
	     logger -i -p warn "TSIEM cleanup: user \`id -u -n\` failed to kill agent process '\$tsiemAgentProcess' with pid \$tsiemAgentPid"
             echo \`date\` TSIEM cleanup: user \`id -u -n\` failed to kill agent process \'\$tsiemAgentProcess\' with pid \$tsiemAgentPid >> \$LOGFILE
  	else
	     logger -i -p warn "TSIEM cleanup: user \`id -u -n\` killed agent process '\$tsiemAgentProcess' with pid \$tsiemAgentPid"
             echo \`date\` TSIEM cleanup: user \`id -u -n\` killed agent process \'\$tsiemAgentProcess\' with pid \$tsiemAgentPid >> \$LOGFILE
        fi
   fi
done

echo \`date\` End of TSIEM cleanup task >> \$LOGFILE
EOF

chmod +x $CEAACTDIR/cleanup.sh

cat > /etc/ibm.tsiem.actuator <<EOF
#!/bin/ksh
####################################################################
# Copyright:  
#   Copyright (c) IBM Corp. 1998,2007. All Rights Reserved.
####################################################################
# ibm.tsiem.actuator -
#  assumes TCP/IP interfaces are brought up by /etc/rc.net
#  starts IBM Tivoli Security Information and Event Manager Actuator for AIX
####################################################################
trap '$CEAACTDIR/cleanup.sh' EXIT
test -x $CEAACTDIR/start-client || exit 0
(cd $CEAACTDIR && ./start-client -nodetach)
EOF

chmod +x /etc/ibm.tsiem.actuator
